// kinem.h  ƻ kinematic wave ǥ

#if !defined(kinem_h)
#define kinem_h

#include <stdio.h>
#include <assert.h>

#include "common.h"    // ̴Ķ
#include "element.h"   // 饹 Element 
#include "p_tmp.h"     // ƥץ졼ȥ饹 Receive, Send 

class Kinem : public Element
{
  protected:

	// ѥ᥿

	double* mK;		// R = mK * pow(A, mZ) (m)
	double* mZ;		// R = mK * pow(A, mZ) (m)
	double mMan;	// ޥ˥󥰤ٷ (m-s)
	double mL;		// ƻĹ (m)
	double mB;      // ƻ (m)
	double mG;		// ƻ (tangent )
	int mDiv;		// ʬ (-)
	double mDx;		// ֺʬֳ (m)
	time_t mDt;		// ֺʬֳ (sec)
	double mTheta;	// ʬŤ߷ (-)

 	double* mAlpha;  // kinematic  
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)

 	double* mM;		// kinematic 
					// mM = 1 + 2/3*mZ

	// 

	double* mQc;	// current_time Ǥή (m3/s)
	double* mQn;	// current_time+time_step Ǥή (m3/s)
	double* mAc;	// current_time Ǥ̿ (m2)
	double* mAn;	// current_time+time_step Ǥ̿ (m2)
	double mQlc;	// current_time Ǥ¦ή (m2/s)
	double mQln;	// current_time+time_step Ǥ¦ή (m2/s)

	// üҡü

	int mNumLateral;			// ¦ή̤ο
	int mNumUpInflow;			// ƻüή

	Receive<double>* rpu;
	Receive<double>* rpl;
	Send<double> sp;

	void Register_receive_ports(void);
	void Register_send_ports(void) { Register((void*) &sp); }

  public:

	Boolean Init(char* o_name, int o_num, int aNumUpInflow, int aNumLateral);
	Kinem(char* o_name, int o_num, int aNumUpInflow, int aNumLateral);
	Kinem(void);
	~Kinem(void)
	{
		delete [] mK; delete [] mZ;
		delete [] mAlpha; delete [] mM;
		delete [] rpu; delete [] rpl;
		delete [] mQc; delete [] mQn;
		delete [] mAc; delete [] mAn;
	}

	// for SCF-style model building
	//////////////////////////////////////////////////////////////////////
	// Returns a pointer to a new Kinem
	Kinem* NewElement() { return (new Kinem()); }
    Boolean Init(char* o_name, int o_num, FILE* fp)
	{
	    int wNumUpInflow; 
		int wNumLateral;
		assert(fscanf(fp, "%d %d", &wNumUpInflow, &wNumLateral) == 2);
        return Init(o_name, o_num, wNumUpInflow, wNumLateral);
	}

  public:

	void Set_parameter(FILE* fp);
	void Set_initial_state(FILE* fp);
	void Save_terminal_state(FILE* fp);

  public:

	Boolean Initial_output(void);
	time_t Calculate_time_step(void);
// 	Boolean Can_you_calculate(void) { return YES; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
	Boolean Work(void) { return Work0(); }
	Boolean Calculate(void);

};

#endif
