/* ksedge.h */
/* $Lastupdate: Mon Jun  4 19:21:03 2007 $ */

#if !defined(ksedge_h)
#define ksedge_h

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"				// ̴Ķ
#include "element.h"            // 饹 Element 
#include "p_tmp.h"              // 饹 Receive, Send 
// #include "khrbktree.h"
#include <map>

class Edge
{
  protected:

	// åδŪʽ

	long mNum;					// åֹ

	// edge connection V.2, V.3 б
	double mX, mY, mZ;			// åκɸ (m)

	// edge connection V.4, V.5 б
	long mUpperNode;			// åüΥΡֹ
	double mUpX, mUpY, mUpZ;	// åü x, y, z ɸ
	long mLowerNode;			// åüΥΡֹ
	double mLowX, mLowY, mLowZ;	// åü x, y, z ɸ

	int mAtr;					// å°
								// 1:ή-ή
								// 2:ή-ƻ
	double mL;					// åĹ(3) (m)
	double mArea;				// å (m2)
	double mWidth;				// å (m)
	double mGrd;				// åθ(sin) (-) 
	double mCos;				// cos(asin(mGrd)) (-)

	int numberOfUpperEdges;		// ή˰֤륨åο
	long* upperEdgeNumArray;	// ή˰֤륨åֹ
								// ؤΥݥ
	Edge** upperEdgeArray;		// ή˰֤륨åؤΥ
								// 쥹򵭲ؤΥݥ
								// 

	int numberOfLowerEdges;		// ή˰֤륨åο
	int* lowerEdgeNumArray;		// ή˰֤륨åֹ
								// ؤΥݥ
	Edge** lowerEdgeArray;		// ή˰֤륨åؤΥ
								// 쥹򵭲ؤΥݥ
								// 

	Boolean lowestEdge;			// ° 2 ǤĲή¦ήХ
								// ¸ߤʤȤ YES, 
								// ʳ NO

	double mUpperArea;			// ή (m2)
								// added on Fri Dec  4 21:41:28 1998

  public:

	long Num(void) { return mNum; }
	int Atr(void) { return mAtr; }
	double Length(void) { return mL; }
	double Area(void) { return mArea; }
	double Width(void) { return mWidth; }
	double Gradient(void) { return mGrd; }
	int NumberOfUpperEdges(void) { return numberOfUpperEdges; }
	Boolean LowestEdge(void) { return lowestEdge; }
	double UpperArea(void) { return mUpperArea; }

	long UpperEdgeNumArray(int i) { return upperEdgeNumArray[i]; }

	// p  upperEdgeArray Ͽ
	Boolean RegisterUpperEdge(Edge* p);

  protected:

	// ήη׻ɬפѿ

	// ѥ᥿

	double mMan;				// ޥ˥󥰤ٷ (m-s)
	double mK;					// Ʃ巸 (m/s)
	double mD;					// Aظ (m)
	double mGamma;				// ַͭΨ (-)

	double mAlpha;				// kinematic wave routing parameter
								// (m-s)
	double mA;					// kinematic wave routing parameter
								// (m-s)
	double mM;					// kinematic wave routing parameter
								// (-)
	double mDepth;				// kinematic wave routing parameter
								// (m)

	// in q = alpha*(h-mDepth)^mM + mA h
	// where q: discharge per unit width,
	// h: water depth (m-s)

	// mAlpha = sqrt(mGrd)/mMan
	// mA = mK * mGrd / mGamma
	// mDepth = mD * mGamma

	int mN;						// ֺʬʬ (-)
	int mDt;					// time step (s)

	// for debugging
	long mT;

	double mTheta; // time weighting parameter (-). The standard value
				   // of mTheta is 0.65.  If mTheta = 0, the finite
				   // difference calculation scheme becomes an explicit
				   // one.
	double mCmin;
	// minimum C = dQ/dA.  If the calculated value of dQ/dA is
	// smaller than cmin, the value is replaced with mCmin.

	double mQlevel;
	// Reference level of discharge calculation (mm/hour). The
	// standard value is 10.0 (mm/hour)

	double mEps;
	// tolerance level of diffrence of two consecutive caluculated
	// discharges to stop the iteration (-). The standard value is
	// 0.001

	double mDist;				// ήʬΨ (-)

	// 

	double* mQc;				// current_time Ǥή (m3/s)

	// ѿ
	double mDx;	   	 // length of the division. mDx = mL/mN (m)
	double* mQn; 	 // next_time Ǥή (m3/s)
	double mQsmall;  // "small" discharge valuse (m3/s)

	double mSarea;				// ˰ (m2)
	double mStorage;			// α (m3)

  public:

	Edge(void)
	{ mL = 0.0; mGrd = 0.0; mArea = 0.0; mWidth = 0.0; mT = 0; }

	~Edge(void)
	{ delete [] upperEdgeArray; delete [] upperEdgeNumArray;
	  delete [] mQc; delete [] mQn; }

	// åη׻¤٤줿 edge connection V.? ե
	// ɤ߹
//	void TopographicData(FILE* fpTopo);
	void TopographicData(FILE* fpTopo, int wTopoDataType);

	// ήη׻ɬפʥѥ᥿ͤɤ߹
	void ParametersInFlowModel
	(
		double man,				// ޥ˥󥰤ٷ (m-s)
	 	double m,				// q = alpha * pow(h, m)  m
	 	double k,				// Ʃ巸 (m/s)
	 	double d,				// Aظ (m)
	 	double gamma,			// ַͭΨ (-)
	 	double theta,			// 
	 	double cmin,			// minimum C = dQ/dA
		double Qlevel,			// 
	 	double eps,				// 
	 	int ndiv,				// ֺʬʬ (-)
	 	int dt					// time_step (s)
	);

	// current_time Ǥξ岼üή̤Ϳη׻̤ή̤
	// ֤ǵ
	void Discharge(double disUpperEnd, double disLowerEnd);

	// current_time Ǥξ岼üή̤֤
	void Discharge(double* disUpperEnd, double* disLowerEnd);

	// mQn ˰°Ѥ׻
	void CalcSatArea(void);

	// mQn α̤׻
	void CalcStorage(void);

  public:

	Boolean Calculate(double r);
	//  : ߿嶯 (mm/hour)
	// Calculate ΤʤǾ̤ιԤʤ

  public:

	// ǲήüή̤֤
	double DischargeLowerEnd(void) { return mQc[mN]; }

	// ήʬΨ mDist ׻
	void DistributionRate(void);

	// ήѤ׻
	void CalcUpperArea(void);

	double
	PropagationSpeed( // ® c ׻֤
    	double aAlpha,  // ѥ᥿ $\alpha$
		double aA,	    // ѥ᥿ a
		double aDepth,  // ѥ᥿ d
    	double aQeps,   // «Ƚ
    	double aQunit   // ñή
	    //
    	// $q = \alpha (h - d)^m + a h$
    	// $c = dq/dh = \alpha m (h - d)^(m-1) + a$
    	//
    );

	double Sarea(void) { return mSarea; }
	double Storage(void) { return mStorage; }
};

// typedef KhKeyedData<long,Edge*> KeyData;

class KsEdge : public Element {

  protected:

	// ü
	Receive<double> rp;
	void Register_receive_ports(void)
	{ Register((void*) &rp); }

	// ü
	Send<double> sp; // ή
	Send<double> spSarea; // ˰Ψ
	Send<double> spStorage; // α
	void Register_send_ports(void)
	{
		Register((void*) &sp);
		Register((void*) &spSarea);
		Register((void*) &spStorage);
	}

  protected:

	// ѥ᥿
	long numberOfEdges; // (å)ο

	int mDt;

	// ()
	Edge* edgeArray;   // Edge ؤΥݥ

	// ѿ
	double mQoutc; // current_time Ǥκǲήü Edge ή̤ (m3/s)
	double mQoutn; // next_time Ǥκǲήü Edge ή̤ (m3/s)
	double mRainn; // next time Ǥι߿嶯 (mm/hour)

	double mSumRain;			// ߿ (m3)
	double mSumQout;			// ή (m3)
	double mSumArea;			// ή (m2)
	double mStorage;			// α (m3) = mSumRain - mSumQout

// 	// Edge ֹ򥭡ˤХʥĥ꡼
// 	KhRbKeyTree<long,Edge*> treeKeyedByEdgeNumber;
	// Edge ֹ򥭡ˤޥå
	map<long,Edge*> mapKeyedByEdgeNumber;

	// åξ岼üή̤򵭤ե̾
	// Set_initial_state ɤ߹ޤΤǡե̾
	// Ƥ
	// åξ岼üή̤򵭤ե
	// (åֹ, üή (m3/s), üή (m3/s))

	char edgeDisFileName[256];

	// Ϸǡμɽѿ
	// ͤˤä Set_parameter ưѤ
	// 1: edge connection V.1 ǡå
	// 2: edge connection V.2 ǡå
	// 3: edge connection V.3 ǡå
	// 4: edge connection V.4 ǡå
	// 5: edge connection V.5 ǡå
	int mTopoDataType;

  public:

	// ؿ󥹥ȥ饯ǥȥ饯

 	Boolean Init(char* o_name, int o_num);

	KsEdge(char* o_name, int o_num);
	// class_name  "KsEdge" ꤷobject_name 
	// o_name ꤹ롣

	KsEdge(void);

// 	~KsEdge(void)
// 	{ delete [] edgeArray; treeKeyedByEdgeNumber.Erase(); }
	~KsEdge(void)
    { delete [] edgeArray; }

	// for SCF-style model building
	//////////////////////////////////////////////////////////////////////
	// Returns a pointer to a new KsEdge
	KsEdge* NewElement() { return (new KsEdge()); }
    Boolean Init(char* o_name, int o_num, FILE*) 
	{ return Init(o_name, o_num); }

  public:

	// ѥ᥿ꡦ̤ν

	void Set_parameter(FILE* fp);
	void Set_initial_state(FILE* fp);
	void Save_terminal_state(FILE* fp);

  public:
	Boolean Initial_output(void);
	time_t Calculate_time_step(void) { return mDt; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
 	Boolean Calculate(void);
	Boolean Work(void) { return Work0(); }

};

#endif
