# makefile

# macro : compile command
# -c: Compile the source file, but do not link.
# -g: Produce debugging information.
CC        = g++
CFLAGS	  = -c -g -Wall

# macro : link command
LD        = g++
LDFLAGS   = -g -o

# macro : files
# BINS : name list of execution files
# OBJS : name list of object files

BINS	= mkPmtIst
OBJS	= mkPmtIst.o khdfstream.o

# rules

all	:	$(BINS) $(OBJS)

mkPmtIst	:	mkPmtIst.o khdfstream.o 
	$(LD) $(LDFLAGS) mkPmtIst mkPmtIst.o khdfstream.o 

mkPmtIst.o	:	mkPmtIst.cc
	$(CC) $(CFLAGS) mkPmtIst.cc $(HEADERDIR)

khdfstream.o	:	khdfstream.cc khdfstream.h
	$(CC) $(CFLAGS) khdfstream.cc $(HEADERDIR)

# etc

clean	:
	/bin/rm -f a.out core *.core *.o $(BINS) *-cc.* *-h.*
