// tsample.cc

#include <stdio.h>
#include <time.h>

#include "total.h"				// class Total_system 
#include "p_tmp.h"
#include "ksedge.h"				// class KsEdge 
#include "kinem.h"              // class Kinem 

// 饹 VirtualRiverBasin 

class VirtualRiverBasin : public Total_system
{

protected:

    // ü
    I_file<double> ip;		  // ߿嶯 (mm/hour)

    // üҤϿ
    void Register_input_ports(void)
    {
        Register((void*) &ip);
    }
	
protected:

    // ü
    O_file<double> op;

    // üҤϿ
    void Register_output_ports(void)
    {
        Register((void*) &op);
    }
		
protected:
    // 
    KsEdge subbasin[3];
    Kinem segment[3];

    // ǤϿ
    void Register_components(void);

    // Ǵȿ׻ѤδؿʤΤǡȤʤ
    void Register_iterators(void) {}

protected:
    // üҤ³
    void Connect_ports(void);

    // ľ̿ѤδؿʤΤǡȤʤ
    void Connect_components(void) {}

public:
    // ֤
    virtual void Set_initial_state(FILE* fp)
    {
        fscanf(fp, "%ld", &current_time);
    }

public:
    // 󥹥ȥ饯
    VirtualRiverBasin(void);

};

// ǤϿ
void VirtualRiverBasin::Register_components(void)
{
    Register((void*) &subbasin[0]);
    Register((void*) &subbasin[1]);
    Register((void*) &subbasin[2]);

    Register((void*) &segment[0]);
    Register((void*) &segment[1]);
    Register((void*) &segment[2]);
}

// üҤ³
void VirtualRiverBasin::Connect_ports(void)
{
    // üҤ subbasin[0] μüҤ³
    Connect(((void*) &ip), ((void*) &subbasin[0]), "Receive", "rp", 0);

    // üҤ subbasin[1] μüҤ³
    Connect(((void*) &ip), ((void*) &subbasin[1]), "Receive", "rp", 0);

    // üҤ subbasin[2] μüҤ³
    Connect(((void*) &ip), ((void*) &subbasin[2]), "Receive", "rp", 0);

    // subbasin[0] ήüҤ segment[0] ¦ή̼üҤ³
    Connect(((void*) &subbasin[0]), "Send", "sp", 0, 
            ((void*) &segment[0]), "Receive", "rpl", 0);

    // subbasin[1] ήüҤ segment[1] ¦ή̼üҤ³
    Connect(((void*) &subbasin[1]), "Send", "sp", 0, 
            ((void*) &segment[1]), "Receive", "rpl", 0);

    // subbasin[2] ήüҤ segment[2] ¦ή̼üҤ³
    Connect(((void*) &subbasin[2]), "Send", "sp", 0, 
            ((void*) &segment[2]), "Receive", "rpl", 0);

    // segment[0] ήüҤ segment[2] ξήüή̼üҤ³
    Connect(((void*) &segment[0]), "Send", "sp", 0, 
            ((void*) &segment[2]), "Receive", "rpu", 0);

    // segment[1] ήüҤ segment[2] ξήüή̼üҤ³
    Connect(((void*) &segment[1]), "Send", "sp", 0, 
            ((void*) &segment[2]), "Receive", "rpu", 1);

    // segment[2] ήüҤüҤ³
    Connect(((void*) &segment[2]), "Send", "sp", 0, ((void*) &op));
}

// 󥹥ȥ饯
VirtualRiverBasin::VirtualRiverBasin(void)
    :	Total_system(),
        ip("tsample.in"),
        op("tsample.out")
{
    // ʬή
    // Ϥ줾졢֥̾, ֹ֥
    subbasin[0].Init("subbasin", 0);
    subbasin[1].Init("subbasin", 1);
    subbasin[2].Init("subbasin", 2);

    // ƻʬ
    // Ϥ줾졢֥̾, ֹ֥, 
    // ήήο, ¦ήο
    segment[0].Init("segment", 0, 0, 1);
    segment[1].Init("segment", 1, 0, 1);
    segment[2].Init("segment", 2, 2, 1);

    class_name = "VirtualRiverBasin";

    // ηϥ饹 
    // ("֥̾", "ֹ֥", "ȿ׻롼פο")
    Init("vrb", 0, 0);
}

// ᥤץ

int main(void)
{
    VirtualRiverBasin vrb;		// ηϥǥ

    if (vrb.Construct() != YES)
    { printf("\n# Failure : Construct.\n"); return 1; }

    if (vrb.Switch() != YES)
    { printf("\n# Failure : Switch.\n"); return 1; }
	
    if (vrb.Are_you_ready() != YES)
    { printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
    // ѥ᥿ե뤫ɤߤȤ
    vrb.Read_parameter_file("tsample.pmt");

    // ֤ե뤫ɤߤȤ
    vrb.Read_initial_state_file("tsample.ist");

    // üҥǡꥹȥ
    vrb.Read_send_port_file("tsample.isd");
	
    vrb.Initial_work();
    vrb.Work();
	
    // ǽ֤ե¸
    vrb.Write_terminal_state("tsample.tst");

    // üҤ˻ĤäƤǡե¸
    vrb.Write_send_port_stock("tsample.tsd");
    return 0;
}
